<!DOCTYPE html>
<html lang="en"> 
<head>
    <title>Fusilli Technical Documentation</title>
    
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    
    <meta name="description" content="Fusilli Technical Documentation">
    <link rel="shortcut icon" href="../favicon.png"> 
    <link href="https://fonts.googleapis.com/css?family=Poppins:300,400,500,600,700&display=swap" rel="stylesheet">
    <script defer src="../assets/fontawesome/js/all.min.js"></script>
	<link rel="stylesheet" href="http://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.15.2/styles/atom-one-dark.min.css">
	<link id="theme-style" rel="stylesheet" href="../assets/css/theme.css">
</head> 

<body class="docs-page">    
    <header class="header fixed-top" id="header">	    
        
    </header>
    
    <div class="docs-wrapper">
	    <div id="docs-sidebar" class="docs-sidebar">
			
	    </div>
	    <div class="docs-content">
		    <div class="container" id="container">
			    <article class="docs-article" id="section-5">
				    <header class="docs-header">
					    <h1 class="docs-heading">Development Patterns <span class="docs-time">Last updated: 2020-12-21</span></h1>
					    <section class="docs-intro">
							<p><b>fusilli.io</b> is designed to remove the human bottlenecks from data projects and to
								make the data accessible to the right people without wasting time.
								The catalog allows you to choose data from different sources using a set of reliable
                connectors.</p>
                <p>In the diagram below is explained how connectors works in fusilli.io-manager:</p>
                <img src="./diagrams/fusilli-connector.PNG" style="width: 920px;">
						</section>
					</header>
					<section class="docs-section" id="item-5-1">
						<h1 class="section-heading">Technologies</h1>
						<p>In fusilli.io different frameworks are used to build the system that will manage the HTTP
							request receveid, listed below all the frameworks and the usage inside fusilli.io </p>
						<p></p>
					</section>

					<section class="docs-section-sub" id="item-5-1-1">
						<h3>Lagom</h3>
						<p>Lagom is an open source framework used to design containerized systems of reactive
							microservices. Lagom builds on <b>Akka</b> and <b>Play</b> and it will manage the actors
							system of Akka.</p>
					</section>

					<section class="docs-section-sub" id="item-5-1-2">
						<h3>Akka and Akka Streams</h3>
						<p>Akka Streams is a module built on top of Akka Actors to make the ingestion and processing of
							streams easy. It provides easy-to-use APIs to create streams that leverage the power of the
							Akka toolkit without explicitly defining actor behaviors and messages.</p>
					</section>

					<section class="docs-section-sub" id="item-5-1-3">
						<h3>Alpakka</h3>
						<p>Alpakka is an Integration library which includes numerous connectors for various commonly used services
							such as databases, file systems, message queues and storage systems.</p>
					</section>
          
          <section class="docs-section" id="item-5-2">
            <h1 class="section-heading">Data Connectors</h1>
            <p>In order to communicate with different types of system fusilli.io uses different types of
							connectors.</p>
						<p>Said connector will allow you to choose from which system you will get and write your data.
						</p>
					</section>

					<section class="docs-section-sub" id="item-5-2-1-1">
						<h3>Files</h3>
						<p>With this connector the fusilli.io manager allows you to use data from a single file, as an
							example we can connect to an <b>SFTP</b> server and extract a specific to use as a source
							of data.</p>
					</section>

					<section class="docs-section-sub" id="item-5-2-1-2">
						<h3>JDBC</h3>
						<p>With the JDBC connector you can connect and use the data of any database that support the JDBC connection such as
							<b>PostgreSQL</b> or <b>Oracle</b></p>
					</section>

					<section class="docs-section-sub" id="item-5-2-1-3">
						<h3>Events</h3>
						<p>The Events connector allows you to use the event coming from a queue or a stream as a data
							source, as an example data coming from <b>Rabbit</b> or <b>Kafka</b></p>
					</section>

					<section class="docs-section-sub" id="item-5-2-1-4">
						<h3>HTTP</h3>
						<p>HTTP connector allow you to communicate with any <b>API</b> to send or receive data from it.
						</p>
          </section>
          
          <section class="docs-section" id="item-5-2-2">
            <h2 class="section-heading">Autodiscovery</h2>
            <p><b>Functional description:</b> Job that performs auto-discovery of a repository (for example PostgreSQL).</p>
            <p>The repository object contains the connection properties to the reference database.</p>
            <p>With the <b>url_data_entry</b> field specifying where to forward the auto discovery result</p>
            <p>It mainly applies auto discovery to relational databases where it is possible to calculate the Metadata of an attribute, in a CSV and / or JSON file everything would be recognized as a String type.</p>
            <p><b>JSON Input:</b></p>
            <pre>
              <code>
                {
                  "url_data_entry": "http://localhost:9000/postme/",
                  "autodiscovery_id": 1,
                  "repository": {
                  "repo_id": 2,
                  "repo_name": "fusilli Data Base",
                  "repo_user": "fusilli_admin",
                  "repo_password": "kdm_fusilli_admin",
                  "repo_type": "postgresql",
                  "host": "localhost",
                  "port": 5430,
                  "schema_path": "fusilli_target"
                }
              }
              
              </code>
            </pre>
            <p><b>JSON Output:</b></p>
            <p>If succedeed, this will be the output:</p>
            <pre>
              <code>
                
              </code>
            </pre>
          </section>
					
					<section class="docs-section" id="item-5-2-3">
						<h2 class="section-heading">Development Blueprints</h2>
						<p><b>fusilli.io-manager</b> is open source so it is possibile to implement and create new <b>Connectors</b> and new <b>Jobs</b>.</p>
						<p>Explained below the process to create a new Connector and a new Job:</p>
          </section>
          
					<section class="docs-section-sub" id="item-5-3-1">
						<h3>Building a Connector</h3>
						<p>To build a new connector create a new <b>Scala</b> file inside the connector folder in the project. and insert the library dependencies in the <b>build.sbt</b> file.</p>
						<p>Extends the <b>“Connector”</b> class as shown below:</p>
<pre>
<code>package com.kdmforce.fusillimanager.impl.connector
import com.kdmforce.fusillimanager.api.EndpointSerializer.{Entity, Repo}
import com.kdmforce.fusillimanager.impl.connectors.Connector
import org.slf4j.{Logger, LoggerFactory}

object MongoDBConnector extends Connector[Any] {
  private final val log: Logger = LoggerFactory.getLogger("")
  override def getSource(repo: Repo, entity: Entity) = {}
  override def getSink(repo: Repo, entity: Entity) = {}
}</code>
</pre>
				<p>Every connector can be used as a <b>Source</b> or a <b>Sink</b>, so is required to implement the methods <b><i>getSource</i></b> and <b><i>getSink</i></b>.</p>
					<p>Is also required to add the new connector as a “case” in the <b>ConnectorActors</b> file, create the new cases inside the objects <b>ConnectorIn</b> and <b>ConnectorOut</b>.</p>
					<h3>ConnectorIn</h3>
<pre>
	<code>case "mysql" =>
    MySQLConnector.getSource(repo, entity)</code>
</pre>
					<h3>ConnectorOut</h3>
<pre>
	<code>case "mysql" =>
    MySQLConnector.getSink(repo, entity)</code>
</pre>
					</section>
					<section class="docs-section-sub" id="item-5-3-2">
						<h3>Building a Job</h3>
						<p>To build a new Job create a new <b>Scala</b> class inside the job folder in the project.</p>
						<p>The new class needs to extend the class <b>“Actor”</b> as shown below:</p>
<pre>
<code>object Concatter {
  def props = Props[Concatter]
	  }	  
class Concatter(instance: Int, job: Job, follower: ActorRef ) extends Actor {
	var index = 0</code>
</pre>
						<p>Inside the class <b>Concatter</b> place the methods used to log as shown below:</p>
<pre>
<code>private val log = Logging.getLogger(context.system, this)

val logger = context.system.actorOf(
  ClusterSingletonProxy.props(
	singletonManagerPath = "/user/logger",
	settings = ClusterSingletonProxySettings(context.system)),
)

override def receive = {
  case PipelineStart =>
	log.info("Start Concatter")
	logger ! (LogMessage(instance, JobMessage("START", "", job.job_configuration_id)))
	follower ! PipelineStart

  case PipelineEnd =>
	log.info("End Concatter")
	logger ! (LogMessage(instance, JobMessage("END", "", job.job_configuration_id)))
	follower ! PipelineEnd
	self ! PoisonPill


  case PipelineError(ex) =>
	log.error(ex, "ERROR on Concatter")
	logger ! (LogMessage(instance, JobMessage("ERROR", ex.getMessage, job.job_configuration_id)))
	follower ! PipelineError(ex)
	self ! PoisonPill

  case el: Map[String, String] =>
	follower ! concatFun(el, job.job_configs)
	}</code>
</pre>
				<p>Then create the <b>function</b> for your job:</p>
<pre>
<code>def concatFun(doc: Map [String,String], jobConfigs: Seq[ConfigValue]): Map[String,String] = {
    var newDoc = doc
    for (j <- jobConfigs) {
      var newVal = List[String]()
      for (attr <- j.input_attrs) {
        newVal = newVal :+ doc(attr)
        newDoc = newDoc - attr
      }
      newDoc = newDoc + (j.output_attrs(0) -> newVal.mkString((j.config \ "spacing").as[String]))
    }
    newDoc
  }
}</code>
</pre>
					<p>As last operation needed add a case inside the function <b>jobMap</b> located inside the <b>“TheOneAfterDispatcher”</b> class as shown below:</p>
<pre>
<code>case "concat" =>
	context.system.actorOf(Props(classOf[Concatter], instance, job,  followers(0)))
</code>
</pre>
					</section>
          

          <section class="docs-section" id="item-5-4">
            <h1 class="section-heading">Transformation Jobs</h1>
            <ul>
              <li>Concatenate.</li>
              <li>Split.</li>
              <li>Rename.</li>
              <li>Replace.</li>
              <li>Mockinbird</li>
							<li>Fork. </li>
							<li>Join.</li>
							<li>Matcher.</li>
              <li>Math.</li>
              <li>Marker</li>
              <li>Stacker</li>
              <li>SplitCloner</li>
            </ul>
            
          <h3>Concatenate</h3>
          <p><b>Functional description:</b> Job that concatenates two fields.</p>
            <p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
            <ul>
							<li>"inputs_attrs": attributes to which the concat operation must be performed</li>
              <li>"outputs_attrs": attribute to which the concat operation was performed</li>
              <li>“config”.”spacing”: chaining character for attributes</li>
            </ul>
              <p><b>JSON Input</b></p>
              <pre>
                <code>
                  {
                    "jobs": [
                    {
                      "job_configuration_id":0,
                      "job_id": 6,
                      "job_name": "concat",
                      "input_edges": [1],
                      "output_edges": [2],
                      "job_configs": [
                        {
                          "input_attrs": [
                            "PROVINCIA","COMUNE"
                          ],
                          "output_attrs": [
                            "RESIDENZA"
                          ],
                          "config": {
                            "spacing": " - "
                          }
                        }
                      ]
                    }
                  ]
                }
                
                </code>
              </pre>

              <h3>Split</h3>
          <p><b>Functional description:</b> Job that split one field.</p>
            <p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
            <ul>
							<li>"inputs_attrs": attribute that must be splitted</li>
              <li>"outputs_attrs": attributes which have been splitted</li>
              <li>“config”.”spacing”: chaining split character for attributes</li>
            </ul>
              <p><b>JSON Input</b></p>
              <pre>
                <code>
                  {
                    "jobs": [
                    {
                      "job_configuration_id":1,
                      "job_id": 6,
                      "job_name": "split",
                      "input_edges": [1],
                      "output_edges": [2],
                      "job_configs": [
                        {
                          "input_attrs": [
                           "DESCRIZIONE_INTERVENTO"
                          ],
                          "output_attrs": [
                              "INIZIO_INTERVENTO",
                              "FINE_INTERVENTO"
                          ],
                          "config": {
                            "spacing": "-"
                          }
                        }
                      ]
                    }
                  ]
                }
                </code>
              </pre>


              <h3>Rename</h3>
              <p><b>Functional description:</b> Job that rename one field.</p>
                <p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
                <ul>
                  <li>"inputs_attrs": attribute that must be renamed</li>
                  <li>"outputs_attrs": attribute which have been renamed</li>
                </ul>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {
                        "jobs": [
                        {
                          "job_configuration_id":1,
                          "job_id": 1,
                          "job_name": "rename",
                          "input_edges": [1],
                          "output_edges": [2],
                          "job_configs": [
                            {
                              "input_attrs": [
                                "PROPRIETARIO_FO"
                              ],
                              "output_attrs": [
                                "POSSESSORE_FO"
                              ],
                              "config": {
                              }
                            }
                          ]
                        }
                      ]
                    }
                    
                    </code>
                  </pre>

                  <h3>Replace</h3>
              <p><b>Functional description:</b> Job that replace on character in one field.</p>
                <p>Mandatory values ​​for correct configuration of the <b>job_configs</b> object are:</p>
                <ul>
                  <li>"inputs_attrs": attribute that must be replaced</li>
                  <li>"outputs_attrs": attributes which have been replaced</li>
                  <li>“config”.”replaced”:character to substitute for attributes</li>
                  <li>“config”.”replacer”: substituent character for attributes</li>
                </ul>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {
                        "jobs": [
                            {
                                "job_configuration_id": 0,
                                "job_id": 6,
                                "job_name": "replace",
                                "input_edges": [
                                    1
                                ],
                                "output_edges": [
                                    2
                                ],
                                "job_configs": [
                                    {
                                        "input_attrs": [
                                            "DESCRIZIONE_INTERVENTO"
                                        ],
                                        "output_attrs": [
                                            "DESCRIZIONE_INTERVENTO"
                                        ],
                                        "config": {
                                            "replaced": "-",
                                            "replacer": "/"
                                        }
                                    }
                                ]
                            }
                        ]
                    }
                    </code>
                  </pre>

                  <h3>Mockinbird</h3>
              <p><b>Functional description:</b> Job that populates one field.</p>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {
                        "jobs": [
                        {
                          "job_configuration_id":0,
                          "job_id": 6,
                          "job_name": "id",
                          "input_edges": [1],
                          "output_edges": [2],
                          "job_configs": []
                        }
                      ]
                    }                    
                    </code>
                  </pre>

                  <h3>Fork</h3>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {
                        "jobs":[
                            {
                                "job_id":1,
                                "job_name":"fork",
                                "input_edges":[
                                    1
                                ],
                                "output_edges":[
                                    2,
                                    3
                                ],
                                "job_configs":[
                                    {
                                        "input_attrs":[
                    
                                        ],
                                        "output_attrs":[
                                            "INIZIO_INTERVENTO",
                                            "FINE_INTERVENTO"
                                        ],
                                        "config":{
                                            "edge":"2"
                                        }
                                    },
                                    {
                                        "input_attrs":[
                    
                                        ],
                                        "output_attrs":[
                                            "COMUNE",
                                            "PROVINCIA"
                                        ],
                                        "config":{
                                            "edge":"3"
                                        }
                                    }
                                ]
                            }
                        ]
                    }                                        
                    </code>
                  </pre>

                  <h3>Join</h3>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {
                        "jobs": [
                          {
                            "job_id": 1,
                            "job_name": "join",
                            "input_edges": [
                              1
                            ],
                            "output_edges": [
                              2
                            ],
                            "job_configs": [
                              {
                                "input_attrs": [],
                                "output_attrs": [],
                                "config": {
                                  "secondary_input": {
                                    "source_id": 1,
                                    "repo_name": "fusilli ftp",
                                    "repo_user": "fusilli_ftp",
                                    "repo_password": "Fu51||1",
                                    "repo_type": "sftp",
                                    "host": "localhost",
                                    "port": 22,
                                    "schema_path": "download/test-file/",
                                    "entities": [
                                      {
                                        "entity_id": 10,
                                        "connection_edge": 1,
                                        "entity_name": "collegamentiinfibraottica2017.csv",
                                        "entity_type": "csv",
                                        "separator": ";",
                                        "attributes": [
                                          {
                                            "attr_name": "PROVINCIA",
                                            "attr_type": "VARCHAR(50)",
                                            "format": "",
                                            "length": ""
                                          },
                                          {
                                            "attr_name": "COMUNE",
                                            "attr_type": "VARCHAR(50)",
                                            "format": "",
                                            "length": ""
                                          },
                                          {
                                            "attr_name": "CODICE_INTERVENTO",
                                            "attr_type": "VARCHAR(50)",
                                            "format": "",
                                            "length": ""
                                          },
                                          {
                                            "attr_name": "DESCRIZIONE_INTERVENTO",
                                            "attr_type": "VARCHAR(50)",
                                            "format": "",
                                            "length": ""
                                          },
                                          {
                                            "attr_name": "LUNGHEZZA_TRATTA_FO",
                                            "attr_type": "INTEGER",
                                            "format": "",
                                            "length": ""
                                          },
                                          {
                                            "attr_name": "PROPRIETARIO_FO",
                                            "attr_type": "VARCHAR(50)",
                                            "format": "",
                                            "length": ""
                                          }
                                        ]
                                      }
                                    ]
                                  },
                                  "matching_fields": [
                                    {
                                      "match_condition": "equals",
                                      "first_one": "String",
                                      "second_one": "String"
                                    },
                                    {
                                      "match_condition": "equals",
                                      "first_one": "String",
                                      "second_one": "String"
                                    }
                                  ]
                                }
                              }
                            ]
                          }
                        ]
                      }
                                                              
                    </code>
                  </pre>

                  <h3>Matcher</h3>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {            
                        "job_configuration_id": 1,            
                        "job_id": 1,            
                        "job_name": "match",            
                        "input_edges": [ 11 ],            
                        "output_edges": [ 84,85 ],  
                        "job_configs":[
                               {
                                 "input_attrs":[],
                                 "output_attrs":[],
                                 "config":[{
                                    "fun":"NAND",
                                    "apply_to":
                                     [{
                                      "verify": "equals",
                                      "key": "COLORE",
                                      "value": "Blu",
                                      "cond_type": "string"
                                      },
                                      {
                                      "verify": "equals",
                                      "key": "FORMA",
                                      "value": "Ics",
                                      "cond_type": "string"
                                      }]
                                 }]
                              }
                            ]
                        }                                                         
                    </code>
                  </pre>

                  <h3>Math</h3>
                  <p><b>JSON Input</b></p>
                  <pre>
                    <code>
                      {
                        "jobs":[
                            {
                                "job_id":1,
                                "job_name":"math",
                                "input_edges":[
                                    1
                                ],
                                "output_edges":[
                                    2
                                ],
                                "job_configs":[
                                    {
                                        "input_attrs":[
                                            "CODICE_INTERVENTO",
                                            "COMUNE",
                                            "PROVINCIA"
                                        ],
                                        "output_attrs":[
                                            "CALCOLO"
                                        ],
                                        "config":{
                                            "operation":"+"
                                        }
                                    }
                                ]
                            }
                        ]
                    }                                                                                 
                    </code>
                  </pre>


          </section>
          
          <section class="docs-section" id="item-5-4-2">
						<h2 class="section-heading">Development Blueprints</h2>
						<p><b>fusilli.io-manager</b> is open source so it is possibile to implement and create new <b>Connectors</b> and new <b>Jobs</b>.</p>
						<p>Explained below the process to create a new Connector and a new Job:</p>
          </section>
          
					<section class="docs-section-sub" id="item-5-4-2-1">
						<h3>Building a Connector</h3>
						<p>To build a new connector create a new <b>Scala</b> file inside the connector folder in the project. and insert the library dependencies in the <b>build.sbt</b> file.</p>
						<p>Extends the <b>“Connector”</b> class as shown below:</p>
<pre>
<code>package com.kdmforce.fusillimanager.impl.connector
import com.kdmforce.fusillimanager.api.EndpointSerializer.{Entity, Repo}
import com.kdmforce.fusillimanager.impl.connectors.Connector
import org.slf4j.{Logger, LoggerFactory}

object MongoDBConnector extends Connector[Any] {
  private final val log: Logger = LoggerFactory.getLogger("")
  override def getSource(repo: Repo, entity: Entity) = {}
  override def getSink(repo: Repo, entity: Entity) = {}
}</code>
</pre>
				<p>Every connector can be used as a <b>Source</b> or a <b>Sink</b>, so is required to implement the methods <b><i>getSource</i></b> and <b><i>getSink</i></b>.</p>
					<p>Is also required to add the new connector as a “case” in the <b>ConnectorActors</b> file, create the new cases inside the objects <b>ConnectorIn</b> and <b>ConnectorOut</b>.</p>
					<h3>ConnectorIn</h3>
<pre>
	<code>case "mysql" =>
    MySQLConnector.getSource(repo, entity)</code>
</pre>
					<h3>ConnectorOut</h3>
<pre>
	<code>case "mysql" =>
    MySQLConnector.getSink(repo, entity)</code>
</pre>
					</section>
					<section class="docs-section-sub" id="item-5-4-2-2">
						<h3>Building a Job</h3>
						<p>To build a new Job create a new <b>Scala</b> class inside the job folder in the project.</p>
						<p>The new class needs to extend the class <b>“Actor”</b> as shown below:</p>
<pre>
<code>object Concatter {
  def props = Props[Concatter]
	  }	  
class Concatter(instance: Int, job: Job, follower: ActorRef ) extends Actor {
	var index = 0</code>
</pre>
						<p>Inside the class <b>Concatter</b> place the methods used to log as shown below:</p>
<pre>
<code>private val log = Logging.getLogger(context.system, this)

val logger = context.system.actorOf(
  ClusterSingletonProxy.props(
	singletonManagerPath = "/user/logger",
	settings = ClusterSingletonProxySettings(context.system)),
)

override def receive = {
  case PipelineStart =>
	log.info("Start Concatter")
	logger ! (LogMessage(instance, JobMessage("START", "", job.job_configuration_id)))
	follower ! PipelineStart

  case PipelineEnd =>
	log.info("End Concatter")
	logger ! (LogMessage(instance, JobMessage("END", "", job.job_configuration_id)))
	follower ! PipelineEnd
	self ! PoisonPill


  case PipelineError(ex) =>
	log.error(ex, "ERROR on Concatter")
	logger ! (LogMessage(instance, JobMessage("ERROR", ex.getMessage, job.job_configuration_id)))
	follower ! PipelineError(ex)
	self ! PoisonPill

  case el: Map[String, String] =>
	follower ! concatFun(el, job.job_configs)
	}</code>
</pre>
				<p>Then create the <b>function</b> for your job:</p>
<pre>
<code>def concatFun(doc: Map [String,String], jobConfigs: Seq[ConfigValue]): Map[String,String] = {
    var newDoc = doc
    for (j <- jobConfigs) {
      var newVal = List[String]()
      for (attr <- j.input_attrs) {
        newVal = newVal :+ doc(attr)
        newDoc = newDoc - attr
      }
      newDoc = newDoc + (j.output_attrs(0) -> newVal.mkString((j.config \ "spacing").as[String]))
    }
    newDoc
  }
}</code>
</pre>
					<p>As last operation needed add a case inside the function <b>jobMap</b> located inside the <b>“TheOneAfterDispatcher”</b> class as shown below:</p>
<pre>
<code>case "concat" =>
	context.system.actorOf(Props(classOf[Concatter], instance, job,  followers(0)))
</code>
</pre>
          </section>

					<section class="docs-section" id="item-5-5">
						<h1>Local Testing</h1>
						<p>To test locally the project run the following command inside the project folder:</p>
						<pre><code>sbt RunAll</code></pre>
						<p>This command will start fusilli.io manager.</p>
                        <p>To test locally the project in debug mode run the following command inside the project folder:</p>
                        <pre><code>sbt -jvm-debug 5005 runAll</code></pre>
                        <p>This command will start fusilli.io manager opening a listening port (in this case 5005). This port must be configured in debug setting in your IDE.</p>
						<p>Fusilli.io manager will be listening on the following URL:</p>
						<pre><code>http://localhost:9000/start</code></pre>
                        <p>It's possible to execute a pipeline via curl command line. Here an example of command line to use (remember to change the JSON pipeline configuration with yours). </p>
                        <pre><code>curl -v -X POST http://localhost:9000/start/ -H 'Content-Type: application/json' -d ''</code></pre>
                        <p>The json body of the request need three objects:</p>
						<ul>
							<li>Inputs</li>
							<li>Outputs</li>
							<li>Jobs</li>
						</ul>
						<p>Shown below an example of the data structure:</p>
						<h3>Inputs</h3>
<pre>
<code>"inputs": [
    {
      "job_configuration_id": 1,
      "source_id": 1,
      "repo_name": "sftp",
      "repo_user": "demo",
      "repo_password": "demo",
      "repo_type": "sftp",
      "host": "localhost",
      "port": 22,
      "schema_path": "/sftp/",
      "entities": [
        {
          "entity_id": 10,
          "connection_edge": 1,
          "entity_name": "collegamentiinfibraottica2017.csv",
          "entity_type": "csv",
          "separator": ";",
          "attributes": [
            {
              "attr_name": "PROVINCIA",
              "attr_type": "VARCHAR(50)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "COMUNE",
              "attr_type": "VARCHAR(50)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "CODICE_INTERVENTO",
              "attr_type": "VARCHAR(50)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "DESCRIZIONE_INTERVENTO",
              "attr_type": "VARCHAR(50)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "LUNGHEZZA_TRATTA_FO",
              "attr_type": "INTEGER",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "PROPRIETARIO_FO",
              "attr_type": "VARCHAR(50)",
              "format": "",
              "length": ""
            }
          ]
        }
      ]
    }
  ]</code>
</pre>
					<h3>Outputs</h3>
<pre>
<code>"outputs": [
    {
      "job_configuration_id": 0,
      "source_id": 6,
      "repo_name": "postgresdb",
      "repo_user": "postgresadmin",
      "repo_password": "admin",
      "repo_type": "postgresql",
      "host": "localhost",
      "port": 5432,
      "schema_path": "postgresdb",  
      "entities": [
        {
          "entity_id": 11,
          "connection_edge": 2,
          "entity_name": "collegamentiinfibraottica2017concat",
          "entity_type": "postgres",
          "separator": ";",
          "attributes": [
            {
              "attr_name": "RESIDENZA",
              "attr_type": "VARCHAR(250)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "CODICE_INTERVENTO",
              "attr_type": "VARCHAR(200)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "DESCRIZIONE_INTERVENTO",
              "attr_type": "VARCHAR(200)",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "LUNGHEZZA_TRATTA_FO",
              "attr_type": "INTEGER",
              "format": "",
              "length": ""
            },
            {
              "attr_name": "PROPRIETARIO_FO",
              "attr_type": "VARCHAR(200)",
              "format": "",
              "length": ""
            }
          ]
        }
      ]
    }
  ]</code>
</pre>
					<h3>Jobs</h3>
<pre>
<code>"jobs": [
    {
      "job_configuration_id": 0,
      "job_id": 6,
      "job_name": "concat",
      "input_edges": [
        1
      ],
      "output_edges": [
        2
      ],
      "job_configs": [
        {
          "input_attrs": [
            "PROVINCIA",
            "COMUNE"
          ],
          "output_attrs": [
            "RESIDENZA"
          ],
          "config": {
            "spacing": " - "
          }
        }
      ]
    }
  ]
}</code>
</pre>
</section>

<section class="docs-section" id="item-5-6">
  <h1 class="section-heading">Unit Testing</h1>
  <h4>Premise</h4>
  <p>All tests were developed using the ScalaTest library.
    Each Unit Test, as such, does not depend on external factors (e.g. databases, servers, etc.).<br>
    All the Job configuration JSONs and their related datasets are present in the Resources directory in the test section of the fusilli-manager project. <br>
    Each test has a dedicated directory in order to make the search and operation on files as fast as possible.
    The configuration JSONs are completely separated from the JSONs for the datasets so as to leave the identity of the configuration file well defined and allow anyone to read, modify or distort it without running into errors, and therefore not change the nature of the standards .</p>
  <h4>How to use the Tests</h4>
  <p>Tests dedicated to the manager can be run from the Command Line once the sbt server is started.</p>
  <p><b>PC>sbt</b></p>
  <p>To run all the tests on all the Jobs (for which the test exists) just use the test command in the Command Line.</p>
  <p><b>PC>test</b></p>
  <p>To run the test suite of a particular Job use the command
    testOnly * TestName</p>
  <p><b>PC>testOnly *ConcatterTest</b></p>
  <p>To run the test suite of a particular Job and monitor the execution time of each individual test of that particular suite, just use the command
    testOnly * TestName - -oD</p>
    <p><b>PC>testOnly *ConcatterTest -- -oD</b></p>
  
    <h2>Tests</h2>


    <h4>Renamer</h4>
    <p>The test for the Job Renamer uses the method present in the Job class and applies the necessary configurations for operation obtained from a properly written JSONs located in the Directory dedicated to the Job. <br>

      In the test, the results obtained from the Job method are compared by providing the datasets present in the Test Directory, with those that await us inserted in the test system always in the form of JSONs.</p>
    <p>The comparison between the two Datasets managed in the form of <i>Map[String, Any]</i>, takes place with the aid of the assert functionality provided by the ScalaTest library.</p>
    <code>assert(productOfMethod == check)</code>  
    
    <p>It also tests the case in which the attributes indicated in the Job configuration file were not present even once with the expectation of the <b>NoSuchElementException</b>.</p>
    <code>assertThrows[NoSuchElementException] {...}</code>  
      <p></p>

    <h4>Splitter</h4>
    <p>The test for the Job Splitter uses the method present in the Job class and applies the necessary configurations for operation obtained from a properly written JSONs located in the Directory dedicated to the Job.</p><br>
    <p>In the test, the results obtained from the Job method are compared by providing the datasets present in the Test Directory, with those that await us inserted in the test system always in the form of JSONs.
      The comparison between the two Datasets managed in the form of <i>Map[String, Any]</i>, takes place with the aid of the assert functionality provided by the ScalaTest library.</p>
    <code>assert(productOfMethod == check)</code>  
    
    <p>It also tests the case in which the attributes indicated in the Job configuration file were not present even once with the expectation of the <b>NoSuchElementException</b>.</p>
    <code>assertThrows[NoSuchElementException] {...}</code>
      <p></p>

    <h4>Concatter</h4>
    <p>The test for the Job Concatter uses the method present in the Job class and applies the necessary configurations for operation obtained from a properly written JSONs located in the Directory dedicated to the Job.</p><br>
    <p>In the test, the results obtained from the Job method are compared by providing the datasets present in the Test Directory, with those that await us inserted in the test system always in the form of JSONs.
      The comparison between the two Datasets managed in the form of <i>Map[String, Any]</i>, takes place with the aid of the assert functionality provided by the ScalaTest library.</p>
    <code>assert(productOfMethod == check)</code>  
    
    <p>It also tests the case in which the attributes indicated in the Job configuration file were not present even once with the expectation of the <b>NoSuchElementException</b>.</p>
    <code>assertThrows[NoSuchElementException] {...}</code>
<p></p>
    
    <h4>Matcher</h4>
    <p>The test for the Job Matcher uses the method present in the file dedicated to the functions of the Job and applies the necessary configurations for operation obtained from a JSONs properly written and located in the Directory dedicated to the Job.</p><br>
    <p>In the test, the results obtained from the Job method are compared by providing the datasets present in the Test Directory, with those that await us inserted in the test system always in the form of JSONs.
      The test checks that the result of the Job method is as expected with the use of the assert functionality provided by the ScalaTest library.</p>
      <p>The expected value, in this test, can only be of Boolean type.</p> <br>
    <code>assert(productOfMethod == check)</code>  
<p></p>

    <h4>Joiner</h4>
    <p>The test for the Job Joiner uses the methods present in the Job class with the aid of the functions dedicated to the particular cases of this Job present in the relative files and applies the necessary configurations for operation obtained from a JSONs properly written and positioned in the Directory dedicated to the Job.</p><br>
    <p>In the test, the results obtained from the Job method are compared by providing the datasets present in the Test Directory, with those that await us inserted in the test system always in the form of JSONs.
      The comparison between the two Datasets managed in the form of <i>Map[String, Any]</i>, takes place with the aid of the assert functionality provided by the ScalaTest library.</p>
    <code>assert(productOfMethod == check)</code>  
    
    <p>It also tests the case in which the attributes indicated in the Job configuration file were not present even once with the expectation of the <b>NoSuchElementException</b>.</p>
    <code>assertThrows[NoSuchElementException] {...}</code>
<p></p>

    <h4>Stacker</h4>
    <p>The test for the Job Stacker uses the methods present in the Job class with the aid of the functions dedicated to the particular cases of this Job present in the relative files and applies the necessary configurations for operation obtained from a JSONs properly written and positioned in the Directory dedicated to the Job.

    </p><br>
    <p>In the test, the results obtained from the Job method are compared by providing the datasets present in the Test Directory, with those that await us inserted in the test system always in the form of JSONs.
      The comparison between the two Datasets managed in the form of <i>Map[String, Any]</i>, takes place with the aid of the assert functionality provided by the ScalaTest library.</p>
    <code>assert(productOfMethod == check)</code>  
    
    <p>It also tests the case in which the attributes indicated in the Job configuration file were not present even once with the expectation of the <b>NoSuchElementException</b>.</p>
    <code>assertThrows[NoSuchElementException] {...}</code>
    
 




</section>
          
          
			    </article>

			    <footer class="footer">
				    <div class="container text-center py-5">
				    </div>
			    </footer>
		    </div> 
	    </div>
    </div>
    
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="../assets/plugins/popper.min.js"></script>
    <script src="../assets/plugins/bootstrap/js/bootstrap.min.js"></script>  
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.15.8/highlight.min.js"></script>
    <script src="../assets/js/highlight-custom.js"></script> 
    <script src="../assets/plugins/jquery.scrollTo.min.js"></script>
    <script src="../assets/plugins/lightbox/dist/ekko-lightbox.min.js"></script> 
	<script src="../assets/js/docs.js"></script>
	
	<script>
		$(document).ready(function () {
			const params = new URLSearchParams(window.location.search)
			if (params.has('search')) {
				var searchbox = document.getElementById('search');
				searchbox.value = params.get('search');
			};
		});

		function searchDoc() {
			//alert($("#search-warn").is(":visible"));
			if ($("#search-warn").is(":visible")) {
				$("#search-warn").toggle();
			};

			var minLength = 3;
			var searchVal = $(document.getElementById('search')).val().trim().toLowerCase();
			//alert(searchVal.length < minLength);
			if (searchVal.length < minLength) {
				$("#search-warn").toggle();
			} else {
				$("#container *").filter(function() {
					//alert($(this).text().toLowerCase().indexOf(value));
					//$(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
					//alert($(this).text());
				});
			}
			return false;
		};
	</script>
<!-- Start: Global site tag (gtag.js) - Google Analytics -->
<script async src="https://www.googletagmanager.com/gtag/js?id=UA-179633743-1"></script>
<script>
  window.dataLayer = window.dataLayer || [];
  function gtag(){dataLayer.push(arguments);}
  gtag('js', new Date());

  gtag('config', 'UA-179633743-1');
</script>

<!-- End: Global site tag (gtag.js) - Google Analytics  -->

</body>
</html> 

